mvqtl_readdata <-
function(inputfile){
  data=scan(inputfile,"")
  n<-length(data)
  if(n==0){ stop("Input data error!") }
  lg<-c()
  pt1<-c()
  pt2<-c()
  map<-c()
  mk<-c()
  indvi<-c()
  
  for(i in 1:n){ 
    if(data[i]=="linkage")  lg<-c(lg,i)
    if(data[i]=="parent1:") pt1<-c(pt1,i)
    if(data[i]=="parent2:") pt2<-c(pt2,i)
    if(data[i]=="map:")     map<-c(map,i)
    if(data[i]=="loci:")     mk<-c(mk,i)
    if(data[i]=="point:") t0<-i
    if(data[i]=="trait1:")  trit<-i
  }
  if(length(lg)==0 || length(pt1)==0 || length(pt2)==0 ||
		length(map)==0 || length(mk)==0 ){
		stop("Input data error!")
  }
  lgn<-length(lg) 
  mklg<-c()
  for(i in 1:lgn){ 
    mklg[i]<-length(data[(pt1[i]+1):(pt2[i]-1)])/3
  } 
  
  for(i in 1:(lgn-1)){
    indvi[i]<-(length(data[(mk[i]+1):(lg[i+1]-1)])/mklg[i])-1 
  }
  indvi[lgn]<-(length(data[(mk[lgn]+1):(t0-2)])/mklg[lgn])-1
  
  
  for(i in 1:(lgn-1)){
    if(indvi[i]!=indvi[i+1]) stop("Input data error! code 1")															
  }
  indv<-indvi[1]
  
  for(i in 1:lgn){ 
    if(length(data[(pt1[i]+1):(pt2[i]-1)])/3!=mklg[i])stop("data error!")
    if(length(data[(pt2[i]+1):(map[i]-1)])/3!=mklg[i])stop("data error!")
    if(length(data[(map[i]+1):(mk[i]-2)])!=mklg[i]-1)stop("data error!")
  }
  for(i in 1:(lgn-1)){
    if(length(data[(mk[i]+1):(lg[i+1]-1)])/(indv+1)!=mklg[i])stop("Input data error!")
  }
  if(length(data[(mk[lgn]+1):(t0-2)])/(indv+1)!=mklg[lgn])stop("Input data error!")
  
  P1<-list(); #ױ1ı
  P2<-list(); #ױ2ı
  MP<-list(); #Mapͼ
  MK<-list(); #Marker
  Y<-list();  #
  
  for(i in 1:lgn){     
    p1<-matrix(data[(pt1[i]+1):(pt2[i]-1)],3,byrow=TRUE);
    p2<-matrix(data[(pt2[i]+1):(map[i]-1)],3,byrow=TRUE);
    mp<-as.numeric(data[(map[i]+1):(mk[i]-2)]);
    
    P1[[i]]<-p1;
    P2[[i]]<-p2;
    MP[[i]]<-mp;   
  }
  
  for(i in 1:(lgn-1)){
    mark<-matrix(data[(mk[i]+1):(lg[i+1]-1)],mklg[i],byrow=TRUE);  
    MK[[i]]<-mark;  
  }
  MK[[lgn]]<-matrix(data[(mk[lgn]+1):(t0-2)],mklg[lgn],byrow=TRUE);
  
  for (i in 1:lgn){
    MK[[i]]<-MK[[i]][,-1];
  }
  
  T<-as.numeric(data[(t0+1):(trit-1)])     #ʱ
  tn=length(T)
  
  if(length(data[(trit+1):(n-1)])/tn!=indv)stop("Input data error!")
  
  Y<-matrix(as.numeric(data[(trit+1):(n-1)]),indv,byrow=TRUE)
  
  print("data opened successfully!")
  
  list(P1,P2,MP,MK,T,Y,indv,lgn,mklg,tn)
}
