mvqtl_regstepwise <- 
function(mk,mkp1,mkp2,y,n,ng,ngi,winsize,gmkdst,ain=0.05,aout=0.1)
{
# adding two new parameters,winsize and gmkdst, in order to chose only one marker 
# in a local region with 2*winsize cM in length. May 5, 2016.
  gyp<-list()
  for(i in 1:ng){
    gyp0<-matrix(0,ngi[i],4); 
    for(j in 1:ngi[i]){
      if(mkp1[[i]][1,j]<mkp2[[i]][1,j]){
        gyp0[j,1]<-paste(mkp1[[i]][1,j],mkp2[[i]][1,j],sep="")
      }else{
        gyp0[j,1]<-paste(mkp2[[i]][1,j],mkp1[[i]][1,j],sep="")
      }
      
      if(mkp1[[i]][1,j]<mkp2[[i]][3,j]){
        gyp0[j,2]<-paste(mkp1[[i]][1,j],mkp2[[i]][3,j],sep="")
      }else{
        gyp0[j,2]<-paste(mkp2[[i]][3,j],mkp1[[i]][1,j],sep="")
      }
      
      if(mkp1[[i]][3,j]<mkp2[[i]][1,j]){
        gyp0[j,3]<-paste(mkp1[[i]][3,j],mkp2[[i]][1,j],sep="")
      }else{
        gyp0[j,3]<-paste(mkp2[[i]][1,j],mkp1[[i]][3,j],sep="")
      }
      
      if(mkp1[[i]][3,j]<mkp2[[i]][3,j]){
        gyp0[j,4]<-paste(mkp1[[i]][3,j],mkp2[[i]][3,j],sep="")
      }else{
        gyp0[j,4]<-paste(mkp2[[i]][3,j],mkp1[[i]][3,j],sep="")
      }
    }
    gyp[[i]]<-gyp0   
  }
  
  xa <- list()
  for(i in 1:ng){
    xt <- list()
    for(j in 1:ngi[i]){
      if(length(unique(gyp[[i]][j,]))==2){
        x0<-matrix(0,n,1);       
        for(k in 1:n){
          if(mk[[i]][j,k]=="aa") {x0[k,1]=1 };
          if(mk[[i]][j,k]=="ab") {x0[k,1]=-1}; 
		  if(mk[[i]][j,k]=="--") {x0[k,1]=0}; 
        }  
      }
      
      if(length(unique(gyp[[i]][j,]))==3){
        x0<-matrix(0,n,2);       
        for(k in 1:n){
          if(mk[[i]][j,k]=="aa") { x0[k,1]=1;x0[k,2]=0 }
          if(mk[[i]][j,k]=="ab") { x0[k,1]=0;x0[k,2]=1 }
          if(mk[[i]][j,k]=="bb") { x0[k,1]=-1;x0[k,2]=-1 } 
		  if(mk[[i]][j,k]=="--") { x0[k,1]=0;x0[k,2]=0.25 }
        }  
      }
      
      if(length(unique(gyp[[i]][j,]))==4){
        x0<-matrix(0,n,3);       
        for(k in 1:n){
          if(mk[[i]][j,k]=="ac") { x0[k,1]=1;x0[k,2]=0;x0[k,3]=0 }
          if(mk[[i]][j,k]=="ad") { x0[k,1]=0;x0[k,2]=1;x0[k,3]=0 }
          if(mk[[i]][j,k]=="bc") { x0[k,1]=0;x0[k,2]=0;x0[k,3]=1 }
          if(mk[[i]][j,k]=="bd") { x0[k,1]=-1;x0[k,2]=-1;x0[k,3]=-1 } 
		  if(mk[[i]][j,k]=="--") { x0[k,1]=0;x0[k,2]=0;x0[k,3]=0 }
        }  
      }
      
      xt[[j]] <- x0		
    }
    xa[[i]] <- xt
  }	
  
  mkstat<-list()   
  for(i in 1:ng){
    mkstat[[i]] <- rep(1,ngi[i])
  }
  
  xop<-rep(1,n)
  fit0<-lm(y ~ 0 + xop)
  
  n2 <- sum(ngi)
  maxstep <- min(c(n2,50))
  
  mkord<-matrix(0,maxstep,4)
    
  step=1 
  while( step<=maxstep ){   
    pop <- 1.0
    for(i in 1:ng)
      for(j in 1:ngi[i])
        if(mkstat[[i]][j]==1){
          x0 <- xa[[i]][[j]]
          x<-cbind(xop,x0);
          fit1<-lm(y ~ 0+x)
          test<-anova(fit1,fit0,test="Wilks")
          lambda<-test$Wilks[2]
          p<-test$Pr[2]
          
          if(p<pop){
            pop<-p
            lgop<-i
            mkop<-j
            xop0<-x
            lbdop<-lambda
            fit1op<-fit1
          }
        }
    
    if(pop >= ain){ break }
    
    mkord[step,1] <- lgop
    mkord[step,2] <- mkop
    mkord[step,3] <- lbdop
    mkord[step,4] <- pop
	for(k in 1:ngi[lgop])
		if(abs(gmkdst[[lgop]][k]-gmkdst[[lgop]][mkop])<winsize){
    		mkstat[[lgop]][k]=0    #gmkdst
		}
    xop <- xop0
    fit0 <- fit1op
    
    maxp <- 1
    while(maxp >= aout ){
      
      if(step>1){
        nx <- c(1)
        for(i in 1:step){
          ii <- mkord[i,1]
          jj <- mkord[i,2]
          nx <- c(nx,ncol(xa[[ii]][[jj]]))
        }
        for(i in 1:step){ nx[i+1] <- nx[i+1] + nx[i] }
        maxp <- 0.0
        for(i in 1:step){
          x00 <- xop[,-((nx[i]+1):nx[i+1])]
          fit00 <- lm(y ~ 0+x00)
          test <- anova(fit0,fit00,test="Wilks")
          p<-test$Pr[2]
          
          if(p > maxp){
            maxp <- p
            mxi <- i
            fit00op <- fit00
            x00op <- x00
          }
        }
        
        if(maxp >= aout){
		   k1 <- mkord[mxi,1]
		   k2 <- mkord[mxi,2]
			for(k in 1:ngi[k1])
				if(abs(gmkdst[[k1]][k]-gmkdst[[k1]][k2])<winsize){
    				mkstat[[k1]][k]=1    #gmkdst
			}

          for(i in mxi:(step-1)) 
            mkord[i,] <- mkord[i+1,]
          xop <- x00op
          fit0 <- fit00op
          step <- step-1
          
        }
        
      }else{
        #step <- step + 1
        maxp <- 0.0
      }
    }
    
    step <- step+1 	      
  }
  step <- step - 1
  list(mkord[1:step,],xa)
}
