mvqtlcim_mapping <-
function(lgi,mki,mkp1,mkp2,mk,mp,y,t,qtlmodeli,
                            bkmks,winsize,mkord,mkx,mfid,gdst,gmkdst,permu=0){
  qtl_model <<- matrix(c('Q','Q','Q','q', 		#model 1
                         'Q','q','Q','Q',		#model 2
                         'Q','q','Q','q',		#model 3
                         'Q','q','q','Q',		#model 4
                         'q1','q2','q3','q4'),	#model 5
                       ncol=4,byrow=TRUE)
 
  qtl <- qtl_model[qtlmodeli,]
  n <- nrow(y)
  m <- ncol(y)
  nt <- ncol(y)
  
  p1 <- matrix(c(mkp1[[lgi]][1,mki],
                 mkp1[[lgi]][3,mki],
                 qtl[1],qtl[2],
                 mkp1[[lgi]][1,mki+1],
                 mkp1[[lgi]][3,mki+1]),
               ncol=2,byrow=TRUE)
  
  p2 <- matrix(c(mkp2[[lgi]][1,mki],
                 mkp2[[lgi]][3,mki],
                 qtl[3],qtl[4],
                 mkp2[[lgi]][1,mki+1],
                 mkp2[[lgi]][3,mki+1]),
               ncol=2,byrow=TRUE)
  d <- mp[[lgi]][mki]
  
  nd <- ceiling(d)

  if(qtlmodeli==1||qtlmodeli==2)nq=2
  if(qtlmodeli==3||qtlmodeli==4)nq=3
  if(qtlmodeli==5)nq=4

  if(permu==0){
  	itvrst <- matrix(0,nrow=nd,ncol=10+nt*nq+nt*nt)
  }else if(permu==1){
  	itvrst <- matrix(0,nrow=nd,ncol=3)
  }else{
   	stop("Parameter error! permu=0 or 1 in QTL mapping")
  } 
  
  bstmk <- mvqtl_backmks(lgi,mki,mp,bkmks,winsize,mkord)
  x0 <- c()
  for(i in 1:bkmks){
    x0 <- cbind(x0,mkx[[bstmk[i,1]]][[bstmk[i,2]]])
  }
  
  x1 <- cbind(rep(1,n),x0)
  xx0 <- t(x1) %*% x1
  invxx0 <- solve(xx0)
  B0 <- invxx0 %*% t(x1) %*% y
  dff <- y - x1 %*% B0
  sigma <- t(dff) %*% dff/n
  invS0 <- solve(sigma)
  lik0 <- -0.5*n*m*(1+log(2*pi))-0.5*n*log(det(sigma))
  
  mu <- B0[1,]    
  xx <- t(x0) %*% x0
  invxx <- solve(xx) %*% t(x0)
  for(d1 in 0.01:d){ 
	cnpb<-mvqtl_conprb(p1,p2,d1,d,mfid)
	cnpb0 <- cnpb[[1]]
	cnpb1 <- cnpb[[2]]					## May 23, 2016
	cnpb2 <- cnpb[[3]]					## May 23, 2016
	rwnms<-rownames(cnpb0)
	clnms<-colnames(cnpb0)
	rwnms1<-rownames(cnpb1)				## May 23, 2016
	rwnms2<-rownames(cnpb2)				## May 23, 2016
	nmk <- length(rwnms)
	nmk1 <- length(rwnms1)					## May 23, 2016
	nmk2 <- length(rwnms2)					## May 23, 2016
	nq <- length(clnms)
	p <- matrix(0,n,nq)
	for(i in 1:n){
		gtpi1 <- mk[[lgi]][mki,i]
		gtpi2 <- mk[[lgi]][mki+1,i]
		gtpi <- paste(gtpi1,gtpi2)
		if(gtpi1!="--" && gtpi2!="--"){
			for(j in 1:nmk)
				if(gtpi==rwnms[j]){
					p[i,]<-cnpb0[j,]
			}
		}else if(gtpi1!="--" && gtpi2=="--"){
			for(j in 1:nmk1)
				if(gtpi1==rwnms1[j]){
					p[i,] <- cnpb1[j,]
				}			
		}else if(gtpi1=="--" && gtpi2!="--"){
			for(j in 1:nmk2)
				if(gtpi2==rwnms2[j]){
					  p[i,] <- cnpb2[j,]
				}			
		}else{
			if(nq==2){ p[i,] <- c(0.5,0.5) }
			if(nq==3){ p[i,] <- c(0.25,0.5,0.25) }
			if(nq==4){ p[i,] <- c(0.25,0.25,0.25,0.25) }
		}
	}
		
    mu1 <- matrix(0,m,nq)
    mu2 <- mu1
    for(i in 1:nq){ mu1[,i] <- mu }
    P <- p
    B10 <- B0[-1,]
    invS1 <- invS0
    XB <- x0 %*% B10
    maxBu <- 1.0
    while(maxBu > 0.000001){
      ydf <- y
      for(i in 1:n){
        spf <- 0
        for(j in 1:nq){
          P[i,j] <- p[i,j]*mvqtl_mnord(y[i,],c(mu1[,j]+XB[i,]),invS1)
          spf <- spf + P[i,j]
        }
        for(j in 1:nq){
          P[i,j] <- P[i,j]/spf
          ydf[i,] <- ydf[i,] - P[i,j]*mu1[,j]		
        }	
      }		
      B1 <- invxx %*% ydf
      XB <- x0 %*% B1
      yXB <- y - XB
      for(j in 1:nq){ mu2[,j] <- t(P[,j])%*%yXB/sum(P[,j]) }	
      S <- matrix(0,m,m)
      for(i in 1:n){
        for(j in 1:nq){
          S <- S + P[i,j]*cbind(c(y[i,]-mu1[,j]-XB[i,])) %*% c(y[i,]-mu1[,j]-XB[i,])
        }
      }
      S <- S/n
      invS1 <- solve(S)
      tmp <- B10
      B10 <- B1
      B1 <- tmp
      tmp <- mu1
      mu1 <- mu2
      mu2 <- tmp
      maxB <- max(abs(B1-B10))
      maxu <- max(abs(mu1-mu2))
      maxBu <- max(c(maxB,maxu))
    }
    
    lik <- 0
    for(i in 1:n){
      spf <- 0
      for(j in 1:nq){
        spf <- spf + p[i,j]*mvqtl_mnord(y[i,],c(mu1[,j]+XB[i,]),invS1)
      }
      lik <- lik + log(spf)
    }
    LR <- 2*(lik-lik0)
	nc0 <- nrow(B1)
	aic <- -2*lik + 2*(nc0+nq)*nt
	bic <- -2*lik + log(n)*(nc0+nq)*nt
    if(permu==0){
	    rstfnl <- c(lgi,mki,d1,round(gdst[lgi]+gmkdst[[lgi]][mki]+d1,2),round(lik0,4),
					round(lik,4),round(LR,6),qtlmodeli,round(aic,4),round(bic,4))
	    for(j in 1:nq){
		  rstfnl <- c(rstfnl,round(mu1[,j],6))
	    }
		for(j in 1:nt)
			for(k in 1:nt){
			rstfnl <- c(rstfnl,round(S[j,k],6))
	    }
	    itvrst[floor(d1)+1,] <- rstfnl
	}
    if(permu==1){
	    rstfnl <- c(lgi,round(LR,6),qtlmodeli)
	    itvrst[floor(d1)+1,] <- rstfnl
	}
  }
  itvrst
}
