mvqtlim_mapping <-
function(lgi,mki,mkp1,mkp2,mk,mp,y,t,qtlmodeli,mfid,gdst,gmkdst,permu=0){
  qtl_model <<- matrix(c('Q','Q','Q','q', 		#model 1
                         'Q','q','Q','Q',		#model 2
                         'Q','q','Q','q',		#model 3
                         'Q','q','q','Q',		#model 4
                         'q1','q2','q3','q4'),	#model 5
                       ncol=4,byrow=TRUE)
 
  qtl <- qtl_model[qtlmodeli,]
  n <- nrow(y)
  m <- ncol(y)
  nt <- ncol(y)
  
  p1 <- matrix(c(mkp1[[lgi]][1,mki],
                 mkp1[[lgi]][3,mki],
                 qtl[1],qtl[2],
                 mkp1[[lgi]][1,mki+1],
                 mkp1[[lgi]][3,mki+1]),
               ncol=2,byrow=TRUE)
  
  p2 <- matrix(c(mkp2[[lgi]][1,mki],
                 mkp2[[lgi]][3,mki],
                 qtl[3],qtl[4],
                 mkp2[[lgi]][1,mki+1],
                 mkp2[[lgi]][3,mki+1]),
               ncol=2,byrow=TRUE)
  d <- mp[[lgi]][mki]
  
  nd <- ceiling(d)

  if(qtlmodeli==1||qtlmodeli==2)nq=2
  if(qtlmodeli==3||qtlmodeli==4)nq=3
  if(qtlmodeli==5)nq=4

  if(permu==0){
  	itvrst <- matrix(0,nrow=nd,ncol=10+nt*nq)
  }else if(permu==1){
  	itvrst <- matrix(0,nrow=nd,ncol=3)
  }else{
   	stop("Parameter error! permu=0 or 1 in QTL mapping")
  } 
  
  my <- colMeans(y)
  dff <- y - rep(1,n) %*% t(my)
  sigma <- t(dff) %*% dff/n
  invS0 <- solve(sigma)
  lik0 <- -0.5*n*m*(1+log(2*pi))-0.5*n*log(det(sigma))
  
  for(d1 in 0.01:d){   
	cnpb<-mvqtl_conprb(p1,p2,d1,d,mfid)
	cnpb0 <- cnpb[[1]]
	cnpb1 <- cnpb[[2]]					## May 23, 2016
	cnpb2 <- cnpb[[3]]					## May 23, 2016
	rwnms<-rownames(cnpb0)
	clnms<-colnames(cnpb0)
	rwnms1<-rownames(cnpb1)				## May 23, 2016
	rwnms2<-rownames(cnpb2)				## May 23, 2016
	nmk <- length(rwnms)
	nmk1 <- length(rwnms1)					## May 23, 2016
	nmk2 <- length(rwnms2)					## May 23, 2016
	nq <- length(clnms)
	p <- matrix(0,n,nq)
	for(i in 1:n){
		gtpi1 <- mk[[lgi]][mki,i]
		gtpi2 <- mk[[lgi]][mki+1,i]
		gtpi <- paste(gtpi1,gtpi2)
		if(gtpi1!="--" && gtpi2!="--"){
			for(j in 1:nmk)
				if(gtpi==rwnms[j]){
					p[i,]<-cnpb0[j,]
			}
		}else if(gtpi1!="--" && gtpi2=="--"){
			for(j in 1:nmk1)
				if(gtpi1==rwnms1[j]){
					p[i,] <- cnpb1[j,]
				}			
		}else if(gtpi1=="--" && gtpi2!="--"){
			for(j in 1:nmk2)
				if(gtpi2==rwnms2[j]){
					  p[i,] <- cnpb2[j,]
				}			
		}else{
			if(nq==2){ p[i,] <- c(0.5,0.5) }
			if(nq==3){ p[i,] <- c(0.25,0.5,0.25) }
			if(nq==4){ p[i,] <- c(0.25,0.25,0.25,0.25) }
		}
	}
	
    mu1 <- matrix(0,m,nq)
    mu2 <- mu1
    for(i in 1:nq){ mu1[,i] <- my }
    P <- p
    invS1 <- invS0
    maxmu <- 1.0
    while(maxmu > 0.000001){
      ydf <- y
      for(i in 1:n){
        spf <- 0
        for(j in 1:nq){
          P[i,j] <- p[i,j]*mvqtl_mnord(y[i,],mu1[,j],invS1)
          spf <- spf + P[i,j]
        }
        for(j in 1:nq){
          P[i,j] <- P[i,j]/spf
          ydf[i,] <- ydf[i,] - P[i,j]*mu1[,j]		
        }	
      }		
      for(j in 1:nq){ mu2[,j] <- t(P[,j])%*%y/sum(P[,j]) }	
      S <- matrix(0,m,m)
      for(i in 1:n){
        for(j in 1:nq){
          S <- S + P[i,j]*cbind(c(y[i,]-mu1[,j])) %*% c(y[i,]-mu1[,j])
        }
      }
      S <- S/n
      invS1 <- solve(S)
      tmp <- mu1
      mu1 <- mu2
      mu2 <- tmp
      maxmu <- max(abs(mu1-mu2))
    }
    
    lik <- 0
    for(i in 1:n){
      spf <- 0
      for(j in 1:nq){
        spf <- spf + p[i,j]*mvqtl_mnord(y[i,],mu1[,j],invS1)
      }
      lik <- lik + log(spf)
    }
    LR <- 2*(lik-lik0)
	aic <- -2*lik + 2*nq*nt
	bic <- -2*lik + log(n)*nq*nt
    if(permu==0){
	    rstfnl <- c(lgi,mki,d1,round(gdst[lgi]+gmkdst[[lgi]][mki]+d1,2),round(lik0,4),
					round(lik,4),round(LR,6),round(aic,4),round(bic,4),qtlmodeli)
	    for(j in 1:nq){
		  rstfnl <- c(rstfnl,round(mu1[,j],6))
	    }
	    itvrst[floor(d1)+1,] <- rstfnl
	}
    if(permu==1){
	    rstfnl <- c(lgi,round(LR,6),qtlmodeli)
	    itvrst[floor(d1)+1,] <- rstfnl
	}

  }
  itvrst
}
