\name{mvqtl_conprb}
\alias{mvqtl_conprb}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Conditional Probablities of QTL genotype
}
\description{
This function is to calculate the conditional probablities of QTL genotype by giving flanking markers
}
\usage{
mvqtl_conprb(p1, p2, d1, d, mfid)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{p1}{
genotype of parent 1
}
  \item{p2}{
genotype of parent 2
}
  \item{d1}{
the distance of test site with the first marker
}
  \item{d}{
total distance of two testing markers
}
  \item{mfid}{
mapping function's id. mfid=1 means Haldane, 2 means Kosambi
}
}
\details{
nothing
}
\value{
nothing
}
\references{
nothing
}
\author{
%%  ~~who you are~~
}
\note{
nothing
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
nothing
}
\examples{
nothing
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function (p1, p2, d1, d, mfid) 
{
    r <- cm2r(d, mfid)
    r1 <- cm2r(d1, mfid)
    r2 = (r - r1)/(1 - 2 * r1)
    h1 = matrix(0, nrow = 3, ncol = 8)
    h2 = matrix(0, nrow = 3, ncol = 8)
    ls = 1
    for (i in 1:2) for (j in 1:2) for (k in 1:2) {
        h1[1, ls] = p1[1, i]
        h1[2, ls] = p1[2, j]
        h1[3, ls] = p1[3, k]
        h2[1, ls] = p2[1, i]
        h2[2, ls] = p2[2, j]
        h2[3, ls] = p2[3, k]
        ls = ls + 1
    }
    hfq = c((1 - r1) * (1 - r2), (1 - r1) * r2, r1 * r2, r1 * 
        (1 - r2), r1 * (1 - r2), r1 * r2, (1 - r1) * r2, (1 - 
        r1) * (1 - r2))/2
    allgtps = matrix("", nrow = 64, ncol = 3)
    allfrqs = rep(0, 64)
    ls = 1
    for (i in 1:8) for (j in 1:8) {
        allgtps[ls, 1] <- paste(h1[1, i], h2[1, j], sep = "")
        allgtps[ls, 2] <- paste(h1[2, i], h2[2, j], sep = "")
        allgtps[ls, 3] <- paste(h1[3, i], h2[3, j], sep = "")
        allfrqs[ls] <- hfq[i] * hfq[j]
        ls = ls + 1
    }
    for (i in 1:64) for (j in 1:3) {
        allgtps[i, j] <- switch(allgtps[i, j], aa = "aa", bb = "bb", 
            cc = "cc", dd = "dd", ab = "ab", ba = "ab", ac = "ac", 
            ca = "ac", ad = "ad", da = "ad", bc = "bc", cb = "bc", 
            bd = "bd", db = "bd", QQ = "QQ", qq = "qq", Qq = "Qq", 
            qQ = "Qq", q1q3 = "q1q3", q3q1 = "q1q3", q1q4 = "q1q4", 
            q4q1 = "q1q4", q2q3 = "q2q3", q3q2 = "q2q3", q2q4 = "q2q4", 
            q4q2 = "q2q4")
    }
    umkgtp1 = unique(allgtps[, 1])
    umkgtp2 = unique(allgtps[, 3])
    uqtlgtp = unique(allgtps[, 2])
    nmk1 = length(umkgtp1)
    nmk2 = length(umkgtp2)
    nqtl = length(uqtlgtp)
    nmk12 = nmk1 * nmk2
    mknms = c()
    for (i in 1:nmk1) for (j in 1:nmk2) mknms = c(mknms, paste(umkgtp1[i], 
        umkgtp2[j]))
    conprb = matrix(0, nrow = nmk12, ncol = nqtl, dimnames = list(mknms, 
        uqtlgtp))
    for (i in 1:nmk12) for (j in 1:nqtl) for (k in 1:64) if (paste(allgtps[k, 
        1], allgtps[k, 3]) == mknms[i] && allgtps[k, 2] == uqtlgtp[j]) 
        conprb[i, j] = conprb[i, j] + allfrqs[k]
    for (i in 1:nmk12) conprb[i, ] = conprb[i, ]/sum(conprb[i, 
        ])
    if (ncol(conprb) == 2) {
        conpr = conprb[, c(2, 1)]
    }
    if (ncol(conprb) == 3) {
        conpr = conprb[, c(3, 2, 1)]
    }
    conprb[order(rownames(conprb)), ]
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
