\name{mvqtlmap}
\alias{mvqtlmap}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
The main function of mapping
}
\description{
This function is composite interval functional mapping program and  interval functional mapping program
}
\usage{
mvqtlmap(inputfile, method = "CIM", qtlmodel = 1:5, nbmk = 15, winsize = 10, mapfuncid = 1, ifpermu = FALSE, permutimes = 1000, np = 1)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{inputfile}{
inputfile is the data file which contains the marker, distance, and phenotype information and so on. 
}
  \item{method}{
CIM or IM
}
  \item{qtlmodel}{
the number of qtlmodel you want to map. 1~5 refers to QQ*Qq,Qq*QQ,Qq*Qq,qQ*Qq,q1q2*q3q4 respectively
}
  \item{nbmk}{
this is the number of background marker get by function of backmks
  \item{winsize}{
the size of window
}
  \item{mapfuncid}{
this is the mapping function, 1 refers to Haldane and 2 refers to Kosambi
}
  \item{ifpermu}{
this is to choose whether you want to do the permutation, and TRUE refers to do the permutation, FALSE refers to not,default=False 
}
  \item{permutimes}{
this is the times you want to do the permutation
}
  \item{np}{
this is the number of cores of the computer, which you choose to use
}
}
\details{
nothing
}
\value{
nothing
}
\references{
nothing
}
\author{
%%  ~~who you are~~
}
\note{
nothing
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
nothing
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function (inputfile, method = "CIM", qtlmodel = 1:5, nbmk = 15, 
    winsize = 10, mapfuncid = 1, ifpermu = FALSE, permutimes = 1000, 
    np = 1) 
{
    if (!file.exists(inputfile)) {
        stop("Input data file does not exist!")
    }
    if (method != "IM" && method != "CIM") {
        stop("Please choose a correct mapping method!")
    }
    rd <- mvqtl_readdata(inputfile)
    nqtlms = length(qtlmodel)
    mkp1 <- rd[[1]]
    mkp2 <- rd[[2]]
    mp <- rd[[3]]
    mk <- rd[[4]]
    t <- rd[[5]]
    y <- rd[[6]]
    n <- rd[[7]]
    ng <- rd[[8]]
    ngi <- rd[[9]]
    nt <- rd[[10]]
    n1 <- nrow(y)
    n2 <- ncol(y)
    gdst <- c()
    gdst[1] <- 0
    for (i in 1:ng) {
        gdst[i + 1] <- gdst[i] + sum(mp[[i]])
    }
    gmkdst <- mp
    for (i in 1:ng) {
        gmkdst[[i]] <- c(0, gmkdst[[i]])
        for (j in 1:(ngi[i] - 1)) {
            gmkdst[[i]][j + 1] <- gmkdst[[i]][j] + mp[[i]][j]
        }
    }
    print("Sampling missing markers...")
    for (i in 1:ng) for (j in 1:ngi[i]) for (k in 1:n) if (mk[[i]][j, 
        k] == "--") {
        mk[[i]][j, k] = mvqtl_sampling_missing_marker(i, j, k, 
            mk, mp, mkp1, mkp2, mapfuncid)
    }
    if (method == "CIM") {
        print("Performing stepwise regression ...")
        regrst <- mvqtl_regstepwise(mk, mkp1, mkp2, y, n, ng, 
            ngi)
        mkord <- regrst[[1]]
        mkx <- regrst[[2]]
        print("Performing CIM QTL mapping ...")
        prefile = unlist(strsplit(inputfile, ".", fixed = TRUE))[1]
        prefile = paste(prefile, "_CIM", sep = "")
        qtlrstfiles <- c()
        for (qtlmodeli in 1:nqtlms) {
            outputfile = paste(prefile, "_M", qtlmodel[qtlmodeli], 
                "Rst.txt", sep = "")
            qtlrstfiles <- c(qtlrstfiles, outputfile)
            if (file.exists(outputfile)) {
                file.remove(outputfile)
            }
            for (lgi in 1:ng) for (mki in 1:(ngi[lgi] - 1)) {
                rst <- mvqtlcim_mapping(lgi, mki, mkp1, mkp2, 
                  mk, mp, y, t, qtlmodel[qtlmodeli], nbmk, winsize, 
                  mkord, mkx, mapfuncid, gdst, gmkdst)
                write.table(rst, outputfile, append = TRUE, quote = FALSE, 
                  row.names = FALSE, col.names = FALSE)
            }
        }
        print("Performing permutaitons ...")
        if (ifpermu) {
            for (qtlmodeli in 1:nqtlms) {
                dirname <- paste(prefile, "_permu", qtlmodel[qtlmodeli], 
                  sep = "")
                if (!dir.exists(dirname)) {
                  dir.create(dirname)
                }
                cls <- makeCluster(np)
                registerDoParallel(cls)
                foreach(lst = 1:permutimes, .export = c("mvqtlcim_mapping", 
                  "cm2r", "mvqtl_conprb", "mvqtl_transprb", "mvqtl_backmks", 
                  "mvqtl_mnord", "f")) \%dopar\% {
                  outpermfile <- paste(dirname, "/", "permu", 
                    qtlmodel[qtlmodeli], "_", lst, ".txt", sep = "")
                  if (file.exists(outpermfile)) {
                    file.remove(outpermfile)
                  }
                  yperm <- y[sample(n1), ]
                  for (lgi in 1:ng) {
                    for (mki in 1:(ngi[lgi] - 1)) {
                      rst <- mvqtlcim_mapping(lgi, mki, mkp1, 
                        mkp2, mk, mp, yperm, t, qtlmodel[qtlmodeli], 
                        nbmk, winsize, mkord, mkx, mapfuncid, 
                        gdst, gmkdst, permu = 1)
                      write.table(rst, outpermfile, append = TRUE, 
                        quote = FALSE, row.names = FALSE, col.names = FALSE)
                    }
                  }
                  return(1)
                }
                stopCluster(cls)
            }
        }
    }
    if (method == "IM") {
        print("Performing interval QTL mapping ...")
        prefile = unlist(strsplit(inputfile, ".", fixed = TRUE))[1]
        prefile = paste(prefile, "_IM", sep = "")
        qtlrstfiles <- c()
        for (qtlmodeli in 1:nqtlms) {
            outputfile = paste(prefile, "_M", qtlmodel[qtlmodeli], 
                "Rst.txt", sep = "")
            qtlrstfiles <- c(qtlrstfiles, outputfile)
            if (file.exists(outputfile)) {
                file.remove(outputfile)
            }
            for (lgi in 1:ng) for (mki in 1:(ngi[lgi] - 1)) {
                rst <- mvqtlim_mapping(lgi, mki, mkp1, mkp2, 
                  mk, mp, y, t, qtlmodel[qtlmodeli], mapfuncid, 
                  gdst, gmkdst)
                write.table(rst, outputfile, append = TRUE, quote = FALSE, 
                  row.names = FALSE, col.names = FALSE)
            }
        }
        print("Performing permutaitons ...")
        if (ifpermu) {
            for (qtlmodeli in 1:nqtlms) {
                dirname <- paste(prefile, "_permu", qtlmodel[qtlmodeli], 
                  sep = "")
                if (!dir.exists(dirname)) {
                  dir.create(dirname)
                }
                cls <- makeCluster(np)
                registerDoParallel(cls)
                foreach(lst = 1:permutimes, .export = c("mvqtlim_mapping", 
                  "cm2r", "mvqtl_conprb", "mvqtl_transprb", "mvqtl_mnord", 
                  "f")) \%dopar\% {
                  outpermfile <- paste(dirname, "/", "permu", 
                    qtlmodel[qtlmodeli], "_", lst, ".txt", sep = "")
                  if (file.exists(outpermfile)) {
                    file.remove(outpermfile)
                  }
                  yperm <- y[sample(n1), ]
                  for (lgi in 1:ng) {
                    for (mki in 1:(ngi[lgi] - 1)) {
                      rst <- mvqtlim_mapping(lgi, mki, mkp1, 
                        mkp2, mk, mp, yperm, t, qtlmodel[qtlmodeli], 
                        mapfuncid, gdst, gmkdst, permu = 1)
                      write.table(rst, outpermfile, append = TRUE, 
                        quote = FALSE, row.names = FALSE, col.names = FALSE)
                    }
                  }
                  return(1)
                }
                stopCluster(cls)
            }
        }
    }
    permrstfiles <- c()
    for (i in 1:nqtlms) {
        dirname <- paste(prefile, "_permu", qtlmodel[i], sep = "")
        if (!dir.exists(dirname)) {
            stop(paste("Permutation did not finish for model", 
                i))
        }
        tmpfile <- paste(dirname, "/", "permu", i, "_1.txt", 
            sep = "")
        if (!file.exists(tmpfile)) {
            stop(paste("Permutation did not finish for model", 
                i))
        }
        pmdat0 <- read.table(tmpfile)
        dmdat0 <- dim(pmdat0)
        pmdat <- pmdat0[, 1:2]
        for (j in 2:permutimes) {
            tmpfile <- paste(dirname, "/", "permu", i, "_", j, 
                ".txt", sep = "")
            if (!file.exists(tmpfile)) {
                stop(paste("Permutation did not finish for model", 
                  i))
            }
            pmdat0 <- read.table(tmpfile)
            dmdat1 <- dim(pmdat0)
            if (dmdat1[1] != dmdat0[1] || dmdat1[2] != dmdat0[2]) {
                stop(paste("Permutation did not finish for model", 
                  i))
            }
            pmdat <- cbind(pmdat, pmdat0[, 2])
        }
        permufile <- paste(prefile, "_PermuM", i, "Rst.txt", 
            sep = "")
        permrstfiles <- c(permrstfiles, permufile)
        write.table(pmdat, permufile, quote = FALSE, row.names = FALSE, 
            col.names = FALSE)
    }
    print("Plotting LR profiles and summarizing QTL mapping results ...")
    plottype = c("pdf", "png", "jpg", "tif", "bmp")
    for (i in 1:nqtlms) {
        for (j in 1:5) {
            mvqtlLRPlot(qtlrstfile = qtlrstfiles[i], permurstfile = permrstfiles[i], 
                wglevel = 1, type = plottype[j])
        }
    }
    for (i in 1:nqtlms) {
        for (j in 1:5) {
            mvqtlLRPlot(qtlrstfile = qtlrstfiles[i], permurstfile = permrstfiles[i], 
                wglevel = 2, type = plottype[j])
        }
    }
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
